<?php



class mosForm_Element extends mosFormDBTable {

	/** @var int Primary key */
	var $id=null;

	/** @var string The label used in the form*/
	var $element_label=null;

	/** @var int The id that defines the element type*/
	var $elementtype_id=null;

	/** @var int The group id that the element belongs to */
	var $group_id=null;

	/** @var string The element name*/
	var $element_name=null;

	/** var string created by date */
    var $created = null;

	/** @var int creator id */
    var $created_by = null;

	/** @var string name of creator */
    var $created_by_alias = null;

	/** @var last date modified */
    var $modified = null;

	/** @var int last user to modifiy the element */
    var $modified_by = null;

	/** @var bol is the element checked out or not */
    var $checked_out = null;

	/** @var datetime time element was checked out at */
    var $checked_out_time = null;
	
	/** @var int width of a field */
	var $element_field_width = null;

	/** @var int width for text box area */
	var $element_width = null;

	/** @var int text box height */
	var $element_height = null;
	
	/** @var bol use wysiwyg editor for text area*/
	var $use_wysiwyg = 0; 

	/** @var string default value */
	var $default  = null;

	/** @var bol is the element visible */
	var $hidden = 0;
	
	/** @var bol is the default value evalued by php */
	var $eval = 0;

	/** @var bol if a field is it as password field */
	var $password = 0;

	/** @var int maximum number of characters in field */
	var $maxlength = null;

	/** @var int is the box checked by default */
	var $box_checked = 0;

	/** @var int is the radio button checked by default */
	var $radio_checked = 0;

	/** @var bol allow multiple selections in drop down lists */
	var $multiple = 0;

	/** @var string drop down text*/
	var $dd_text = null;
	
	/** @var string initially selected value for the drop down */
	var $dd_intial_selection = null;

	/** @var string minimum selection */
	var $dd_min_selection = null;

	/** @var string maximum selection */
	var $dd_max_selection = null;

	/** @var string dropdown values */
	var $dd_values = null;

	/** @var string image name */
	var $image_name = null;

	/** @var int order of element */
	var $ordering = null;

	/** @var string checkbox values */
	var $ck_value = null;

	/** @var string radio button values */
	var $rad_value = null;
	
	/** @var string A csv list of file types that are allowed to be uploaded - eg image/gif,image/jpg*/
	var $ul_file_types = null;
	
	/** @var string The directory to upload teh file to */
	var $ul_directory = null;
	
	/** @var int maxium file size allowed to be uploaded (kb)*/
	var $ul_max_file_size = null;
	
	/** @var bol states if uploaded file is emailed to recipient*/ 
	var $ul_email_file = 0;
	
	/** @var bol states if uploaded files of the same name should be renamed to avoid overwriting exisiting file*/
	var $ul_file_increment = 0;
	
	/** @var bol show the element in the table summary */
	var $show_in_table_summary = 0;
	
	/** @var int id to mosform database connection*/
	var $join_conn_id = null;
	
	/** @var string table name to make data join with*/  
	var $join_db_name = null;
	
	/** @var string column name to use as foregin key - this will match the column value */
	var $join_key_column = null;
	
	/** @var string column name to replace the column value with */
	var $join_val_column = null;
	
	/** @var bol alllows people to order by this column in table view*/
	var $can_order = 0;
	
	/** @var bol allows people to filter by this column in table view */
	var $can_filter = 0;
	
	/** @var string filter type dropdown or field*/
	var $filter_type = null;
	
	/** @var bol filter search string exact (true) or partial (false) match will return record*/
	var $filter_exact_match = 0;
	
	/** @var bol published state of element*/
	var $state = 0;
	
	/** @var string javascript to run on button press */
	var $button_javascript = null;

	/** @var string float value for image (left, right, none);*/
	var $image_float = null;        
        
    /** @var string url to create image link from */
    var $link_url = null;
    
    /** @var bol states if the element acts as a link though to the row's detail page*/
     var $link_to_detail = 0;
     
     /** @var bol is this element a primary key for the table */
    var $primary_key = 0;
	
	 /** @var bol if primary key then is it an autoincrementing number */
    var $auto_increment = 0;
    
    /** @var bol sets if this elements data is added to the page title */
    var $use_in_page_title = 0;
	
	/**

	* @param database A database connector object

	*/

	function mosForm_Element( &$db ) {

		$this->mosDBTable( '#__mosform_elements', 'id', $db );

	}

	// overloaded check function

	function check() {

		// check for valid name

		/*if (trim( $this->element_label) == '') {

			$this->_error = "Your Element must contain a label.";

			return false;

		}*/

		return true;

	}
	
	function copyRow($id, $updateOrderColumns){
		
		global $database;

		$tbl = $this->_tbl;
		
		$_tbl_key = $this->_tbl_key;
		
		//get the data to copy
		$sql = "select * from $tbl where $_tbl_key = '$id'";

		$database->setQuery( $sql );
		
		$item = $database->loadObjectList();
		
		$item = $item[0];
		
		//add the data to this object as long as its not the key
		
		if(is_array($item)){
				
			foreach($item as $key=>$val){
				
				if($key != 	$_tbl_key){
					
					$this->$key = $val;
					
				}
				
			}

		}
		
		if (!$this->check()) {
			
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			
			exit();
			
		}
		if (!$this->store()) {
			
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			
			exit();
			
		}
		
		//parse the update code to state which columns get updated
		$updatewhere = "";
		
		if(is_array($updateOrderColumns)){
				
			foreach($updateOrderColumns as $key=>$val){
				
				if (substr($val,0,4) == '$row') { //here we replace the value with date created from the row
				
				    $val = $row->$key;
				    
				}
				
				$updatewhere .= " $key = '$val' and";
				
			}
			
		}
		
		//strip the last and from the where statement
		$updatewhere = substr($updatewhere,0,strlen($updatewhere)-3 );
		
		$this->updateOrder( $updatewhere  );
		
	}

}


?>